%bcond_without repolib

%define section free
%define reltag _redhat_1
%define namedversion %{version}-redhat-1

Name:           apache-cxf-xjc-utils
Version:        2.4.0
Release:        9%{reltag}%{?dist}
Summary:        Apache CXF XJC Utils

Group:          Development/Libraries
License:        ASF 2.0
URL:            http://cxf.apache.org
# svn export http://svn.apache.org/repos/asf/cxf/xjc-utils/tags/xjc-utils-2.4.0/
# tar -jcf apache-cxf-xjc-utils-2.4.0.tar.bz2 xjc-utils-2.4.0
Source0:        apache-cxf-xjc-utils-2.4.0.tar.bz2
Source1:        apache-cxf-xjc-utils-jpp-depmap.xml
Patch0:         apache-cxf-xjc-utils-vman-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  jpackage-utils 
BuildRequires:  maven2
BuildRequires:  maven-plugin-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-checkstyle-plugin
BuildRequires:  maven-pmd-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-shared
BuildRequires:  maven-shared-downloader
BuildRequires:  jboss-parent
BuildRequires:  jvnet-parent

Requires: jpackage-utils
Requires(post): jpackage-utils 
Requires(postun): jpackage-utils 

BuildRequires:  glassfish-jaxb
BuildRequires:  jboss-jaxb-api_2.2_spec
BuildRequires:  jakarta-commons-lang
BuildRequires:  jboss-specs-parent
BuildRequires:  wsdl4j
BuildRequires:  relaxngDatatype
BuildRequires:  xml-commons-resolver
# glassfish-jaxb needs
BuildRequires:  codemodel
BuildRequires:  istack-commons
BuildRequires:  xsom
BuildRequires:  dtd-parser
BuildRequires:  txw2 
BuildRequires:  txwc2 
BuildRequires:  rngom

Requires:  glassfish-jaxb
Requires:  jakarta-commons-lang
Requires:  jboss-jaxb-api_2.2_spec
Requires:  jboss-specs-parent
Requires:  wsdl4j
Requires:  relaxngDatatype
Requires:  xml-commons-resolver

%description
Apache CXF XJC Utils

%package -n cxf-xjc-dv
Summary:        Apache CXF XJC Default Value Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-dv
%{summary}.

%package -n cxf-xjc-ts
Summary:        Apache CXF XJC toString Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-ts
%{summary}.

%package -n cxf-xjc-boolean
Summary:        Apache CXF XJC Boolean Getter Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-boolean
%{summary}.

%package -n cxf-xjc-plugin
Summary:        Apache CXF XSD2Java Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-plugin
%{summary}.

%package -n cxf-xjc-wsdlextension
Summary:        Apache CXF XJC WSDL Extension Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-wsdlextension
%{summary}.

%package -n cxf-xjc-pl
Summary:        Apache CXF XJC Property Listener Plugin
Group:          Development/Java
Requires:       apache-cxf-xjc-utils

%description -n cxf-xjc-pl
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.


%prep
%setup -q -n xjc-utils-2.4.0

%patch0 -p1

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mvn-jpp \
        -e \
        -Dmaven2.jpp.mode=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        -DaltDeploymentRepository=jboss-releases::default::file:maven2-brew \
        deploy javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}/%{name}
install -m 644 dv/target/cxf-xjc-dv-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-dv-%{namedversion}.jar
install -m 644 ts/target/cxf-xjc-ts-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-ts-%{namedversion}.jar
install -m 644 boolean/target/cxf-xjc-boolean-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-boolean-%{namedversion}.jar
install -m 644 cxf-xjc-plugin/target/cxf-xjc-plugin-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-plugin-%{namedversion}.jar
install -m 644 wsdlextension/target/cxf-xjc-wsdlextension-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-wsdlextension-%{namedversion}.jar
install -m 644 property-listener/target/cxf-xjc-pl-%{namedversion}.jar   %{buildroot}%{_javadir}/%{name}/cxf-xjc-pl-%{namedversion}.jar

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; \
    do ln -sf ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

%add_to_maven_depmap org.apache.cxf.xjc-utils xjc-utils %{namedversion} JPP/%{name} xjc-utils
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-dv %{namedversion} JPP/%{name} cxf-xjc-dv
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-ts %{namedversion} JPP/%{name} cxf-xjc-ts
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-boolean %{namedversion} JPP/%{name} cxf-xjc-boolean
%add_to_maven_depmap org.apache.cxf cxf-xjc-plugin %{namedversion} JPP/%{name} cxf-xjc-plugin
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-wsdlextension %{namedversion} JPP/%{name} cxf-xjc-wsdlextension
%add_to_maven_depmap org.apache.cxf.xjcplugins cxf-xjc-pl %{namedversion} JPP/%{name} cxf-xjc-pl

# poms
install -d -m 755 %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-xjc-utils.pom
install -pm 644 dv/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-dv.pom
install -pm 644 ts/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-ts.pom
install -pm 644 boolean/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-boolean.pom
install -pm 644 cxf-xjc-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-plugin.pom
install -pm 644 wsdlextension/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-wsdlextension.pom
install -pm 644 property-listener/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-pl.pom

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
rm -rf target/site/api*

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_datadir}/maven2/poms/JPP.%{name}-xjc-utils.pom
%{_mavendepmapfragdir}/%{name}

%files -n cxf-xjc-dv
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-dv-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-dv.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-dv.pom

%files -n cxf-xjc-ts
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-ts-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-ts.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-ts.pom

%files -n cxf-xjc-boolean
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-boolean-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-boolean.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-boolean.pom

%files -n cxf-xjc-plugin
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-plugin-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-plugin.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-plugin.pom

%files -n cxf-xjc-wsdlextension
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-wsdlextension-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-wsdlextension.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-wsdlextension.pom

%files -n cxf-xjc-pl
%defattr(-,root,root,-)
%{_javadir}*/%{name}/cxf-xjc-pl-%{namedversion}.jar
%{_javadir}*/%{name}/cxf-xjc-pl.jar
%{_datadir}/maven2/poms/JPP.%{name}-cxf-xjc-pl.pom

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri May 04 2012 Hui Wang <huwang@redhat.com> - 2.4.0-9_redhat_1
- Update pom patch to remove repositories
- BR codemodel, istack-commons, xsom, dtd-parser, txw2, txwc2 and rngom which glassfish-jaxb depdends on

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 2.4.0-8_redhat_1.3.1
- Rebuild using cache signing

* Mon Mar 25 2012 Yong Yang <yyang@redhat.com> - 0:2.4.0-8_redhat_1.2
- Update vman patch, set the wsdlextension dep's version, xjc-plugin cannot resolve extension's dep's version by BOMs
- Add BR jvnet-parent

* Wed Feb 08 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.0-8_redhat_1.2
- Use new resolver package

* Fri Jan 27 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.0-8_redhat_1.1
- Do not reqire maven2 at run-time

* Wed Dec 21 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-8_redhat_1
- Add Requires for sub-packages
- Add dependencies and B(R)s for xml-commons-resolver12, relaxngDatatype, these are needed for runtime

* Tue Dec 20 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-7_redhat_1
- Update vman patch
- Add jpp-depmap for jtidy

* Thu Dec 01 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-6_redhat_1
- Add cxf-xjc-pl

* Wed Nov 30 2011 Yong Yang <yyang@redhat.com> - 0:2.4.0-5_redhat_1
- Fix cxf-xjc-plugin groupId

* Wed Nov 30 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-4_redhat_1
- Fix repolib

* Tue Nov 29 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-3_redhat_1
- Rebuild

* Tue Nov 29 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-2_redhat_1
- Add cxf-xjc-plugin and cxf-xjc-wsdlextension artifacts

* Tue Oct 25 2011 Hui Wang <huwang@redhat.com> - 0:2.4.0-1_redhat_1
- Upgrade tp 2.4.0

* Wed Sep 21 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-3
- Build for wolf

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-2
- Add workaround for deploy-file bug that causes wrong directory of cxf-xjc-boolean.pom and cxf-xjc-bug671.pom

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.2-1
- Upgrade to 2.3.2

* Thu Jul 28 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-3
- Rebuild

* Thu Jul 21 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-2
- Rebuild

* Tue Jul 19 2011 Hui Wang <huwang@redhat.com> - 0:2.3.0-1
- First release
